#!/bin/bash

cd `dirname $0`

# import the scripts
source "param_func.sh"
source "param_api.sh"

# this function is mandatory if you want to show some help
# you must also put it BEFORE reading any parameter
function usage()
{
  echo "Usage : ./install.sh [options]"
  echo "   -s                      Simple switch"
  echo "   --test1 VAL             Value with one param"
  echo "   --test3 VAL1 VAL2 VAL3  Value with 3 params"
  echo "   --help or -h            Default parameters"
}

# add one boolean switch and one arg with one parameter
readSwitch "-s" "switch_enabled"
readParam "--test1" "p_test1" "aDefaultValue"
readParam "--test3" "p_var1" "default1" "p_var2" "default2" "p_var3" "default3"

# this will read all the dynamic parameters that are left on the command line.
# it must be read AFTER all the parameters have been read
# for example in the line ./script-sample.sh --test3 1 2 3 4 5, this value will
# contain "4 5"
readLeftParams "leftParams"

# always call this function BEFORE doing any processing, so the script can
# exit if parameters are wrong !
showHelp

# now you can begin your processing and use the variables you defined as parameter !
# here you can see that the variables are correctly set, depending upon your parameters
echo "-s                        switch_enabled=${switch_enabled}"
echo "--test1 VAL               p_test1=${p_test1}"
echo "--test3 VAL1 VAL2 VAL3    p_var1=${p_var1}, p_var2=${p_var2}, p_var3=${p_var3}"
echo "dynamic values:           ${#leftParams[@]}"
for ((i=0 ; i<${#leftParams[@]} ; i++)); do
echo "                          $i = ${leftParams[$i]}"
done
